

function init()
	--Register tool and enable it
	RegisterTool("christmaslights", "Christmas Lights", "MOD/vox/gun.vox")
	SetBool("game.tool.christmaslights.enabled", true)
	maxdistance = 100
	mindistance = 2
	ui = false
	helpui = false
	menu = 0
	menuimage = "MOD/img/menu.jpg"
	SetFloat("game.tool.christmaslights.ammo", 60)
	if not HasKey("savegame.mod.keybind") then
		SetString("savegame.mod.keybind", "P")
	end
	keybind = GetString("savegame.mod.keybind")

	gunSnd = LoadSound("MOD/snd/gunsnd.ogg")
	rldSnd = LoadSound("MOD/snd/gunload.ogg")
	cannonSnd = LoadSound("MOD/snd/cannon.ogg")
	if not HasKey("savegame.mod.color") then SetString("savegame.mod.color", "default") end
	if not HasKey("savegame.mod.intensity") then SetString("savegame.mod.intensity", "0.5") end
	if not HasKey("savegame.mod.space") then SetString("savegame.mod.space", "0.75") end
	if not HasKey("savegame.mod.order") then SetString("savegame.mod.order", "sequential") end
	if not HasKey("savegame.mod.glare") then SetString("savegame.mod.glare", "true") end
	if not HasKey("savegame.mod.pattern") then SetString("savegame.mod.pattern", "none") end
	if not HasKey("savegame.mod.delay") then SetString("savegame.mod.delay", "30") end
	if not HasKey("savegame.mod.length") then SetString("savegame.mod.length", "original") end
	if not HasKey("savegame.mod.height") then SetString("savegame.mod.height", "1") end
	if not HasKey("savegame.mod.firemode") then SetString("savegame.mod.firemode", "line") end
	if not HasKey("savegame.mod.sound") then SetString("savegame.mod.sound", "true") end
	if not HasKey("savegame.mod.slack") then SetString("savegame.mod.slack", "-0.2") end

	colorOptions = {
		["default"] = {
			"0.1 1.0 0.1",
			"1.0 0.1 0.1",
			"1.0 1.0 0.1",
			"0.1 0.1 1.0"
		},
		["saturated"] = {
			"0.0 1.0 0.0",
			"1.0 0.0 0.0",
			"1.0 1.0 0.0",
			"0.0 0.0 1.0"
		},
		["tricolor"] = {
			"1.0 0.1 0.15",
			"0.1 1.0 0.4",
			"1.0 1.0 0.5"
			
		},
		["white"] = {
			"1.0 1.0 1.0"
		},
		["red"] = {
			"1.0 0.35 0.35"
		},
		["orange"] = {
			"1.0 0.5 0.0"
		},
		["yellow"] = {
			"1.0 0.75 0.5"
		},
		["green"] = {
			"0.5 1.0 0.5"
		},
		["blue"] = {
			"0.5 0.75 1.0"
		},
		["purple"] = {
			"1.0 0.5 1.0"
		},
		["garfield"] = {
			"1.0 0.4 0.0",
			"0.0 0.0 0.0"
		},
		["candycane"] = {
			"1.0 0.0 0.0",
			"1.0 1.0 1.0"
		},
		["police"] = {
			"1.0 0.0 0.0",
			"0.0 0.0 1.0"
		}
	}


	function alterTwinkle(list, cycle)
		length = 1
		if list.length then
			length = list.length
		end
		if math.floor(list.index/length)%2 == 1 then
			return math.floor(cycle/list.delay)%2 == 1
		else
			return math.floor(cycle/list.delay)%2 == 0
		end
	end

	function seqTinkle(list, cycle)
		if not list.length then
			return syncSeqTinkle(list, cycle)
		end
		for n = 0,list.length do
			if list.index%list.length == n then
				return math.floor(cycle/list.delay)%list.length == n
			end
		end
		return false
	end

	function syncSeqTinkle(list, cycle)
		return math.floor(cycle/list.delay)%list.len == list.cindex - 1
	end

	function randomTinkle(list, cycle)
		math.randomseed(cycle/list.delay)
		if not list.gindex then
			list.gindex = list.index
		end
		for i = 1,list.gindex do
			math.random()
		end
		return math.random() > 0.5
	end

	twinkleFunctions = {
		["none"] = "",
		["alternating"] = alterTwinkle,
		["sequential"] = seqTinkle,
		["random"] = randomTinkle
	}

	colorKeys = {}
	twinkleKeys = {}
	for name, v in pairs(colorOptions) do
		--DebugPrint(name)
		table.insert(colorKeys, name)
	end
	for name, v in pairs(twinkleFunctions) do
		
		table.insert(twinkleKeys, name)
	end

	firstPosition = false
	firstNormal = false
	lightlist = {}
	placemode = "shoot"
	globalindex = 0
	anglesnap = false
end

--from infinite cable mod
function SpawnCable(from,to, rot, size)
	if not size then size = .1 end
	local fromString = table.concat(from," ")
	local toString = table.concat(to," ")
	local rotString = table.concat(rot," ")

	cableStrength = 10
	local ropeXML = [[
	<rope color="0.05 0.05 0.05" slack="]] .. GetString("savegame.mod.slack") .. [[" size="]] .. size .. [[" strength="]] .. cableStrength .. [[">
	<location pos="]] .. fromString .. [[" rot="]] .. rotString .. [["/>
	<location pos="]] .. toString .. [[" rot="]] .. rotString .. [["/>
	</rope>]]
	return Spawn(ropeXML,Transform(),false,true)
end

--Return a random vector of desired length
function rndVec(length)
  local v = VecNormalize(Vec(math.random(-100,100), math.random(-100,100), math.random(-100,100)))
  return VecScale(v, length)  
end

function splitstr (inputstr, sep)
	if sep == nil then
			sep = "%s"
	end
	local t={}
	for str in string.gmatch(inputstr, "([^"..sep.."]+)") do
		table.insert(t, str)
	end
	return t
end

function raycast(t, lookTo, iter)
	if not iter then iter = 0 end
	if not t then
		t = GetCameraTransform()
	end
	local fwd = TransformToParentVec(t, Vec(0,0,-1))
	local maxDist = 200
	local hit, dist, normal, shape = QueryRaycast(t.pos, fwd, maxDist)
	if not hit then
		dist = maxDist
	end
	--DebugPrint(normal[1] .. " " .. normal[2] .. " " .. normal[3])
	--[[if dist < .1 and lookTo and iter < 2 then
		t.pos = VecAdd(t.pos, VecScale(normal, 2))
		t.rot = QuatLookAt(t.pos, lookTo)
		DebugCross(t.pos)
		return raycast(t, lookTo, iter+1)
	end]]--
	local e = VecAdd(t.pos, VecScale(fwd, dist))
	return hit, dist, normal, shape, e
end

local previousitems = {}

local lastpos
local timesum = 0
local DoCancel = false
local cycle = 0
local lightcounter = 0
local startval = 0
local guntransform = Transform()
local equipped = false

function tick(dt)

	cycle = cycle + 1
	timesum = timesum + dt
	if #lightlist > 0 then
		for i, larray in pairs(lightlist) do
			if not IsBodyBroken(larray.handle) and GetBodyMass(larray.handle) > 0 then
				on = larray.func(larray, cycle)
				SetLightEnabled(larray.obj, on)
			else
				SetLightEnabled(larray.obj, false)
				table.remove(lightlist[i])
			end
			--DebugPrint(on)
		end
	end
	local function placeLight(lightpos, rotation, i, rindex, dojoint, temp)
		local twinklePattern = twinkleFunctions[GetString("savegame.mod.pattern")]
		local currentColor = colorOptions[GetString("savegame.mod.color")]
		local lightIntensity = GetString("savegame.mod.intensity")
		local glare = GetString("savegame.mod.glare")
		local height = tonumber(GetString("savegame.mod.height"))
		if glare == "true" then glare = "0.1" else glare = "0.0" end
		
		randcolor = currentColor[rindex]
		jointinfo = '<joint id_="1093928192" pos=".05 .05 .05" type="ball" size=".1"/>'
		if not dojoint or temp then
			jointinfo = ""
		end
		
		local xml = [[
			<voxbox size='1 1 1' pos="-.05 -.05 -.05" prop='true' material='metal' color='0.05 0.05 0.05'>
				<voxbox size='1 ]] .. height .. [[ 1' pos="0 ]] .. -0.1 * height .. [[ 0" prop='false' material='glass' pbr='0 0 0 15' color=']] .. randcolor ..[['>
					<light id_="146350816" pos=".05 .05 .05" color="]] .. randcolor .. [[" scale="]] .. lightIntensity .. [[" glare="]] .. glare .. [[" size=".05"/>
				</voxbox>
				]].. jointinfo .. [[
			</voxbox>
		]]
		if temp then
			xml = [[
				<voxbox size='1 1 1' pos="-.05 -.05 -.05" prop='false' collide='false' tags='nocull' material='metal' color='0.05 0.05 0.05'>
					<voxbox size='1 ]] .. height .. [[ 1' pos="0 ]] .. -0.1 * height .. [[ 0" prop='false' material='glass' pbr='0 0 0 15' collide='false' tags='nocull' color=']] .. randcolor ..[[' texture='1' density='1' strength='1'>
						<light id_="146350816" pos=".05 .05 .05" color="]] .. randcolor .. [[" scale="]] .. lightIntensity .. [[" glare="]] .. glare .. [[" size=".05"/>
					</voxbox>
					]].. jointinfo .. [[
				</voxbox>
			]]
		end
		spawntable = Spawn(xml,Transform(VecAdd(lightpos, Vec(0,0,0)), rotation), true, true)
		local lightobj = spawntable[4]
		--Delete(spawntable[1])
		
		if not temp then
			ParticleType("smoke")
			ParticleEmissive(0,0)
			ParticleRadius(0,.5)
			ParticleAlpha(1,0)
			ParticleTile(3)
			ctab = splitstr(randcolor)
			ParticleColor(ctab[1], ctab[2], ctab[3])
			SpawnParticle(lightpos, Vec(0,0,0),.2)
		end
		if twinklePattern ~= "" and not temp then
			globalindex = globalindex+1
			table.insert(lightlist, {
				["func"] = twinklePattern,
				["obj"] = lightobj,
				["index"] = i,
				["len"] = #currentColor,
				["cindex"] = rindex,
				["delay"] = tonumber(GetString("savegame.mod.delay")),
				["length"] = tonumber(GetString("savegame.mod.length")),
				["gindex"] = globalindex,
				["handle"] = spawntable[1]
			})
		end
		return spawntable
	end
	local function spawnLights(start, finish, temp)
		local strDistance = VecLength(VecSub(start,finish))
		if previousitems then
			for _, item in pairs(previousitems) do
				Delete(item)
			end
		end
		previousitems = {}
		
		currentColor = colorOptions[GetString("savegame.mod.color")]
		lightIntensity = GetString("savegame.mod.intensity")
		spacing = tonumber(GetString("savegame.mod.space"))
		glare = GetString("savegame.mod.glare")
		if glare == "true" then glare = "0.1" else glare = "0.0" end
		height = tonumber(GetString("savegame.mod.height"))
		
		twinklePattern = twinkleFunctions[GetString("savegame.mod.pattern")]
		
		order = GetString("savegame.mod.order")
		
		if GetString("savegame.mod.sound") == true then PlaySound(gunSnd, GetPlayerPos(),.5) end
		local startval = math.random(1,#currentColor)
		local numberlights = math.floor(strDistance/spacing)
		local lastlightpos = start
		local rotation = QuatLookAt(start, finish)
		rx, ry, rz = GetQuatEuler(rotation)
		if math.abs(rx) > 80 then
			rotation = QuatRotateVec(rotation, Vec(0,0,90))
		end
		--DebugPrint(rx .. " " .. ry .. " " .. rz)
		for i = 1, numberlights-1 do
			local randcolor
			local rindex
			if order == "sequential" then
				rindex = (startval+i)%(#currentColor)+1
			elseif order == "random" then
				rindex = math.random(1,#currentColor)
			end
			
			randcolor = currentColor[rindex]
			
			lightpos = VecLerp(start,finish, i/numberlights)
			local dojoint = false
			if i%2 == 1 and i < numberlights-1 then
				dojoint = true
				
			end
			local spawntable = placeLight(lightpos, rotation, i, rindex, dojoint, temp)
			
			
			if lastlightpos and not temp then
				local cables = SpawnCable(lastlightpos,lightpos, rotation)
				if temp then
					for _, val in pairs(cables) do
						table.insert(previousitems, val)
					end
				end
			end
			lastlightpos = lightpos
			
			if temp then
				for _, val in pairs(spawntable) do
					table.insert(previousitems, val)
				end
				table.insert(previousitems, spawntable)
			end
		end
		if not temp then
			local cable = SpawnCable(lastlightpos,finish, rotation)
			if temp then
				for _, val in pairs(cable) do
					table.insert(previousitems, val)
				end
			end
		end
		
	end
	if GetString("game.player.tool") == "christmaslights" then
		mindistance = tonumber(GetString("savegame.mod.space"))*2
		if not equipped then
			if GetString("savegame.mod.sound") == true then PlaySound(rldSnd, GetPlayerPos(),1) end
			guntransform = Transform(Vec(0,0,0), QuatEuler(-30,0,0))
		end
		equipped = true
		local toolbody = GetToolBody()
		function fireParticle()
			ParticleType("smoke")
			ParticleEmissive(5,0)
			ParticleRadius(0,2)
			ParticleAlpha(1,0)
			ParticleTile(0)
			ParticleColor(1, 1, 1)
			local camTrans = GetCameraTransform()
			camTrans.pos = TransformToParentPoint(camTrans, Vec(0.35, -0.45, -0.45))
			local fwd = TransformToParentVec(camTrans,Vec(0,0,-1))
			guntransform = Transform(Vec(0,0,1), QuatEuler(30,0,0))
			SpawnParticle(camTrans.pos, VecScale(fwd, 15),.5)
			if GetString("savegame.mod.sound") == true then PlaySound(cannonSnd, GetPlayerPos(),.5) end
		end
		SetToolTransform(guntransform)
		guntransform.pos = VecLerp(guntransform.pos, Vec(0,0,0), .1)
		guntransform.rot = QuatSlerp(guntransform.rot, QuatEuler(0,0,0), .1)
		if GetString("savegame.mod.firemode") == "gun" and not ui then
			currentColor = colorOptions[GetString("savegame.mod.color")]
			if InputPressed("lmb") then
				startval = math.random(1,#currentColor)
				local hit, dist, normal, shape, pos = raycast()
				if hit then
					if GetString("savegame.mod.sound") == true then PlaySound(gunSnd, GetPlayerPos(),1) end
					firstPosition = pos
					placeLight(firstPosition, Quat(), 1, startval, true, false)
					fireParticle()
				end
			end
			
			if InputDown("lmb") then
				spacing = tonumber(GetString("savegame.mod.space"))
				local hit, dist, normal, shape, pos = raycast()
				local stringlength = VecLength(VecSub(firstPosition, pos))
				local cursorlen = VecLength(VecSub(lastpos, pos))
				if cursorlen > spacing then
					timesum = 0
				end
				
				--local hit, dist, normal, shape, pos = raycast(Transform(firstPosition, QuatLookAt(firstPosition, pos)), pos)
				
				lastpos = pos
				if stringlength>=spacing/2 and stringlength < maxdistance then
					if timesum > .1 then
						
						
						lightcounter = lightcounter + 1
						local order = GetString("savegame.mod.order")
						local rindex
						if order == "sequential" then
							rindex = (startval+lightcounter-1)%(#currentColor)+1
						elseif order == "random" then
							rindex = math.random(1,#currentColor)
						end
						
						placeLight(pos, Quat(), lightcounter, rindex, true, false)
						timesum = 0
						rotation = QuatLookAt(firstPosition, pos)
						spawnLights(firstPosition, pos)
						--local cable = SpawnCable(firstPosition,pos, rotation)
						firstPosition = pos
						fireParticle()
					end
				else
					timesum = 0
				end
	
			end
			
			if InputReleased("lmb") then
				lightcounter = 0
			end
		else
			local function snapangle(pos1, pos2, normal, shape)
				local transform = GetShapeWorldTransform(shape)
				local rx, ry, rz = GetQuatEuler(transform.rot)
				--DebugPrint(rx .. " " .. ry .. " " .. rz)
				transform.pos = pos1
				
				--local normtrans = Transform(pos1, QuatLookAt(Vec(0,0,0), normal))
				local normpos = TransformToLocalPoint(transform, pos2)
				--[[local minval = math.min(math.abs(normpos[1]),math.min(math.abs(normpos[2]),math.abs(normpos[3])))
				if minval == math.abs(normpos[1]) then
					pos2 = TransformToParentPoint(normtrans, Vec(0,normpos[2],normpos[3]))
				elseif minval == math.abs(normpos[2]) then
					pos2 = TransformToParentPoint(normtrans, Vec(normpos[1],0,normpos[3]))
				else
					pos2 = TransformToParentPoint(normtrans, Vec(normpos[1],normpos[2],0))
				end]]--
				
				local function upar(vec)
					return TransformToParentPoint(transform, vec)
				end
				
				
			
				local maxval = math.max(math.abs(normpos[1]),math.max(math.abs(normpos[3]),math.abs(normpos[2])))
				if maxval == math.abs(normpos[1]) then
					pos2 = upar(Vec(normpos[1],0,0))
					DebugLine(upar(Vec(-100,0,0)), upar(Vec(100,0,0)),0,1,0,0.5)
					DebugLine(upar(Vec(0,-100,0)), upar(Vec(0,100,0)),0,0,1,0.25)
					DebugLine(upar(Vec(0,0,-100)), upar(Vec(0,0,100)),0,0,1,0.25)
				elseif maxval == math.abs(normpos[2]) then
					pos2 = upar(Vec(0,normpos[2],0))
					DebugLine(upar(Vec(0,-100,0)), upar(Vec(0,100,0)),0,1,0,0.5)
					DebugLine(upar(Vec(-100,0,0)), upar(Vec(100,0,0)),0,0,1,0.25)
					DebugLine(upar(Vec(0,0,-100)), upar(Vec(0,0,100)),0,0,1,0.25)
				else
					pos2 = upar(Vec(0,0,normpos[3]))
					DebugLine(upar(Vec(0,0,-100)), upar(Vec(0,0,100)),0,1,0,0.5)
					DebugLine(upar(Vec(-100,0,0)), upar(Vec(100,0,0)),0,0,1,0.25)
					DebugLine(upar(Vec(0,-100,0)), upar(Vec(0,100,0)),0,0,1,0.25)
				end
				
				return pos2
			end
			if InputPressed("lmb") then
				local hit, dist, normal, shape, pos = raycast()
				firstPosition = pos
				firstNormal = normal
			end
			if InputReleased("lmb") then
				if not DoCancel then
					local hit, dist, normal, shape, pos = raycast()
					if anglesnap then
						pos = snapangle(firstPosition, pos, normal, shape)
					end
					local strDistance = VecLength(VecSub(firstPosition,pos))
					
					if strDistance > mindistance and strDistance < maxdistance then
						spawnLights(firstPosition, pos, false)
					end
				else
					DoCancel = false
				end
			end
			
			if InputPressed("rmb") and InputDown("lmb") then
				DoCancel = true
				if previousitems then
					for _, item in pairs(previousitems) do
						Delete(item)
					end
				end
				previousitems = {}
			elseif InputPressed("rmb") then
				anglesnap = not anglesnap
			end
			if InputDown("lmb") and not DoCancel then
				local hit, dist, normal, shape, pos = raycast()
				
				if anglesnap then
					pos = snapangle(firstPosition, pos, normal, shape)
				end
				
				local strDistance = VecLength(VecSub(firstPosition,pos))

				r = 0
				if strDistance < mindistance or strDistance > maxdistance then
					r = 1
				end
				DebugLine(firstPosition, pos, r,0,0)
				
				if VecLength(VecSub(lastpos, pos)) > .001 and timesum > .1 then
					if strDistance > mindistance and strDistance < maxdistance then
						spawnLights(firstPosition, pos, true)
						lastpos = pos
						timesum = 0
					else
						if previousitems then
							for _, item in pairs(previousitems) do
								Delete(item)
							end
						end
						previousitems = {}
					end
				end
			end
		end
	else
		equipped = false
	end
end

function property(name, list, key)
	local current = GetString(key)
	if current == "" then 
		current = list[1]
	end
	UiAlign("center middle")
	UiPush()
		UiPush()
			UiTranslate(-0,0)
			UiFont("MOD/fnt/germania.ttf", 27)
			UiText(name)
		UiPop()
		UiTranslate(0, 25)
		UiPush()
			UiFont("MOD/fnt/germania.ttf", 27)
			if UiTextButton(current) then
				local new = nil
				for i=1, #list-1 do
					if list[i] == current then
						new = list[i+1]		
					end
				end
				if new then
					SetString(key, new)
				else
					SetString(key, list[1])
				end
			end
		UiPop()
	UiPop()
end

local drawCycle = 0

function draw()
	drawCycle = drawCycle+1
	if GetString("game.player.tool") == "christmaslights" then
		UiFont("MOD/fnt/germania.ttf", 22)
		UiTextShadow(0, 0, 0, 0.5, 0.5)
		UiTextOutline(0,0,0,1.0,.2)
		
		if not uix then uix = UiWidth() - 100 end
		if not uiy then uiy = UiMiddle()*2-100 end
		
		UiTranslate(uix, uiy)
		
		if InputPressed(keybind) then
			ui = not ui
			if ui then
				SetValue("uix", UiCenter(), "cosine", 0.25)
				SetValue("uiy", UiMiddle(), "cosine", 0.25)
			else
				SetValue("uix", UiWidth()-100, "cosine", 0.25)
				SetValue("uiy", UiMiddle()*2-100, "cosine", 0.25)
			end
		end
		
		if ui then
			UiBlur(1.0)
			UiAlign("center middle")
			UiFont("MOD/fnt/germania.ttf", 30)
			local w, h = UiGetImageSize(menuimage)
			UiPush()
				UiTranslate(0,0)
				UiImage(menuimage)
			UiPop()
			UiTranslate(0,-h/2+30)
			UiMakeInteractive()
			UiColor(1,.8,.5)
			UiPush()
				UiTranslate(0, -45)
				UiText("Press " .. string.upper(keybind) .. " to hide")
			UiPop()
			function helpText(text)
				if helpui and UiIsMouseInRect(120,30) then
					UiPush()
						UiAlign("left middle")
						UiTranslate(190, 0)
						UiFont("MOD/fnt/germania.ttf", 20)
						UiColor(1,1,1)
						UiText(text)
					UiPop()
				end
			end
			if menu == 0 then
				UiPush()
					UiColor(1,.5,.5)
					UiText("Light Settings")
					UiColor(1,.8,.5)
					UiPush()
						UiTranslate(-70,0)
						
						UiTranslate(0, 40)
						UiPush()
							UiFont("MOD/fnt/germania.ttf", 27)
							UiText("Color")
							UiTranslate(0, 25)
							UiFont("MOD/fnt/germania.ttf", 27)
							if UiTextButton("choose") then
								menu = 1
							end
							--[[property("Color", colorKeys, "savegame.mod.color")
							helpText("Default & Saturated = Red,Yellow,Green,Blue\nTricolor = Red,Yellow\nGarfield = Orange & Black\nCandycane = Red & White")]]--
						UiPop()
						
						UiTranslate(0, 60)
						property("Intensity", {"0.1", "0.2", "0.5", "1.0"}, "savegame.mod.intensity")
						helpText("Brightness and Reach of light")

						UiTranslate(0, 60)
						property("Spacing", {"0.25", "0.50", "0.75", "1.00", "1.25","1.50"}, "savegame.mod.space")
						helpText("Roped distance between individual lights")
						
						UiTranslate(0, 60)
						property("Order", {"sequential", "random"}, "savegame.mod.order")
						helpText("Sequential = fixed color pattern that repeats\nRandom = random color pattern sampled from all colors")
						
						UiTranslate(0, 60)
						property("Glare", {"true", "false"}, "savegame.mod.glare")
						helpText("Image plane that appears over lights to simulate glare")
					UiPop()
					UiPush()
						UiTranslate(70,0)
						
						UiTranslate(0, 40)
						property("Height", {"1","2","3"}, "savegame.mod.height")
						helpText("How tall the light is")
						
						UiTranslate(0, 60)
						property("Rope Slack", {"-0.4","-0.3", "-0.2", "-0.1", "0.0"}, "savegame.mod.slack")
						helpText("How tight/loose the strings connecting the lights are\nLower = tighter")
						
						UiTranslate(0, 60)
						property("Fire Mode", {"line", "gun"}, "savegame.mod.firemode")
						helpText("Line = click and drag to place a straight line of lights\nGun = try it out :)")
						
						UiTranslate(0, 60)
						property("Sound", {"true", "false"}, "savegame.mod.sound")
						helpText("Mute/unmute audio")
					UiPop()
					
				UiPop()
				UiTranslate(0, 340)
				if UiTextButton("Reset to Defaults") then
					SetString("savegame.mod.color", "default")
					SetString("savegame.mod.intensity", "0.5")
					SetString("savegame.mod.space", "0.75")
					SetString("savegame.mod.glare", true)
					SetString("savegame.mod.order", "sequential")
					SetString("savegame.mod.height", "1")
					SetString("savegame.mod.firemode", "line")
					SetString("savegame.mod.slack", "-0.2")
				end
				UiTranslate(0,50)
				UiColor(1,.5,.5)
				if UiTextButton("Show Twinkle Settings") then
					menu = 2
				end
			elseif menu == 1 then
				local function drawButton(name)
					local colors = colorOptions[name]
					local fclr = splitstr(colors[1])
					UiColor(fclr[1],fclr[2],fclr[3])
					if UiTextButton(name) then
						SetString("savegame.mod.color", name)
					end
					UiTranslate(0,40)
				end
				UiPush()
					UiPush()
						UiTranslate(-70,0)
						drawButton("default")
						drawButton("saturated")
						drawButton("tricolor")
						drawButton("garfield")
						drawButton("candycane")
						drawButton("police")
					UiPop()
					UiPush()
						UiTranslate(70,0)
						drawButton("red")
						drawButton("orange")
						drawButton("yellow")
						drawButton("green")
						drawButton("blue")
						drawButton("purple")
					UiPop()
				UiPop()
				UiTranslate(0, 390)
				if UiTextButton("Done") then
					menu = 0
				end
			else
				UiPush()
					UiColor(1,.5,.5)
					UiText("Twinkle Settings")
					UiColor(1,.8,.5)
					UiTranslate(0, 40)
					property("Twinkle Pattern", twinkleKeys, "savegame.mod.pattern")
					helpText("Alternating = half of lights are on while others are off\nSequential = one light is lit one after the other based on its order on the rope\nrandom = each individual light has a random 50% chance of being lit")
					if GetString("savegame.mod.pattern") ~= "none" then
						UiTranslate(0, 60)
						property("Twinkle Delay", {"10", "20", "30", "40", "50", "60"}, "savegame.mod.delay")
						helpText("Time between each pattern change")
						
						UiTranslate(0, 60)
						property("Sequence Length", {"original", "2", "3", "4", "5", "6"}, "savegame.mod.length")
						helpText("In alternating = number of adjacent lights lit, original is one light lit\nin Sequential = space between individually lit lights, original is based on color pattern size")
					end
					
				UiPop()
				UiTranslate(0, 340)
				if UiTextButton("Reset to Defaults") then
					SetString("savegame.mod.pattern", "none")
					SetString("savegame.mod.delay", "30")
					SetString("savegame.mod.length", "original")
				end
				UiTranslate(0,50)
				UiColor(1,.5,.5)
				if UiTextButton("Show Light Settings") then
					menu = 0
				end
			end
			UiColor(1,1,1)
			UiTranslate(0,30)
			if not helpui then
				if UiTextButton("Enable Help") then
					helpui = not helpui
				end
			else
				if UiTextButton("Disable Help") then
					helpui = not helpui
				end
			end
			UiTranslate(0,30)
			local colorlist = colorOptions[GetString("savegame.mod.color")]
			local numlights = math.floor(4/tonumber(GetString("savegame.mod.space")))
			local width = 400
			UiColor(0,0,0)
			UiRect(width,5)
			
			UiTranslate(-width/2,0)
			local height = tonumber(GetString("savegame.mod.height"))
			
			for i = 1,numlights do
				local intensity = tonumber(GetString("savegame.mod.intensity"))*2
				UiPush()
					local colorindex = (i-1)%#colorlist+1
					local color = splitstr(colorlist[colorindex])
					if GetString("savegame.mod.pattern") ~= "none" then
						local uilist = {
							["index"] = i,
							["len"] = #colorlist,
							["cindex"] = colorindex,
							["delay"] = tonumber(GetString("savegame.mod.delay")),
							["length"] = tonumber(GetString("savegame.mod.length"))
						}
						local bool = twinkleFunctions[GetString("savegame.mod.pattern")](uilist, drawCycle)
						--DebugPrint(bool)
						if not bool then intensity = 0 end
					end
					UiTranslate(i/(numlights+1)*width,0)
					UiColor(0,0,0)
					UiRect(10,10)
					UiTranslate(0,5+height*10/2)
					UiColor(color[1]*intensity,color[2]*intensity,color[3]*intensity)
					if GetString("savegame.mod.glare") == "true" then
						UiPush()
							UiColorFilter(color[1]*intensity,color[2]*intensity,color[3]*intensity,intensity*.5)
							UiImageBox("MOD/img/gradient.png",10+20,height*10+20)
						UiPop()
					end
					
					UiRect(10,height*10)
					
				UiPop()
			end
		else
			UiAlign("center middle")
			UiText("Press " .. string.upper(keybind) .. " to configure")
			if anglesnap then
				UiPush()
					UiColor(0.7,0.7,1)
					UiTranslate(0,-25)
					UiFont("MOD/fnt/germania.ttf", 30)
					UiText("Angle Snap")
				UiPop()
			end
		end
	end
end


